// map, groups, stars, msg,info
var currentSection = "map";
var isAuth = false;
var nick = null;
var userid = -1;
var W,H;
var autoScrollMap = true;
var currentPosition = null;
var map = null;

var isowner = 0;
var groupname = "";
var groupid = -1;
var ownername = "";
var isingroup = 0;

var idcostellazione = -1;
var costellazionename = "";
var costellazioneimmagine = "";

var updateMessagingTimer;

var usercoordinatestimer = null;
var groupupdatecoordinatestimer = null;
var checkWinTimer = null;

var currentConstellationMarkers;
var myMarker;
var groupMarkers;
var onStarMarkers;


var staricon = new google.maps.MarkerImage('http://www.artisopensource.net/ciccit/staricon.png',
      new google.maps.Size(20, 20),
      new google.maps.Point(0,0),
      new google.maps.Point(10, 10));
	  
var meicon = new google.maps.MarkerImage('http://www.artisopensource.net/ciccit/meicon.png',
      new google.maps.Size(30, 30),
      new google.maps.Point(0,0),
      new google.maps.Point(15, 15));
	  
var gpicon = new google.maps.MarkerImage('http://www.artisopensource.net/ciccit/gpicon.png',
      new google.maps.Size(20, 20),
      new google.maps.Point(0,0),
      new google.maps.Point(10, 10));
	  
var onstaricon = new google.maps.MarkerImage('http://www.artisopensource.net/ciccit/onstaricon.png',
      new google.maps.Size(30, 30),
      new google.maps.Point(0,0),
      new google.maps.Point(25, 25));


var mapStyleStyle;

$(document).ready(function(){
   
   	$(window).resize(function() {
  		resizehandler();
	});
   
   	setTimeout(function() { window.scrollTo(0, 1); }, 1);
	
	verifyLogin();
	
	currentConstellationMarkers = new Array();
	groupMarkers = new Array();
	onStarMarkers = new Array();
	
	resizehandler();
	loadSection("map");   
   	
	initButtons();
	
	if(usercoordinatestimer !=null){
		clearTimeout(usercoordinatestimer );	
	}
	usercoordinatestimer = setTimeout("initGeoPosition()",1000);
	
 });
 
 
function initGeoPosition(){
	
	//geoWatchID = navigator.geolocation.watchPosition(updatePosition);
	navigator.geolocation.getCurrentPosition(updatePosition, notPossibleToGetPosition);
}
 
function notPossibleToGetPosition(error){
	// gestire il fatto che non c'è la posizione
	if(usercoordinatestimer !=null){
		clearTimeout(usercoordinatestimer );	
	}
	usercoordinatestimer = setTimeout("initGeoPosition()",20000);
}

function updatePosition(position){
	
	var lastPosition = currentPosition;
	var d = 0.001;
	currentPosition = position;
	
	if(lastPosition!=null){
		d = Math.sqrt(   (currentPosition.coords.latitude-lastPosition.coords.latitude)*(currentPosition.coords.latitude-lastPosition.coords.latitude) +  (currentPosition.coords.longitude-lastPosition.coords.longitude)*(currentPosition.coords.longitude-lastPosition.coords.longitude)  );	
	}
	
					if(myMarker!=null){
						myMarker.setMap(null);
						myMarker = null;	
					}
					var myLatlng = new google.maps.LatLng(currentPosition.coords.latitude,currentPosition.coords.longitude);
					myMarker = new google.maps.Marker({
      					position: myLatlng,
						icon: meicon,
      					title:"Me!"
  					});
					
					if(map!=null){
						myMarker.setMap(map);	
					}
	
	if(autoScrollMap && map!=null ){
		map.panTo( new google.maps.LatLng(currentPosition.coords.latitude,currentPosition.coords.longitude)  );
		autoScrollMap = false;
	}
	
	if(isAuth && userid!=-1 && (d>=0.0001||groupid!=-1) ){
		$.getJSON("storeCoordinates.php",
			{
				lat: currentPosition.coords.latitude,
				lon: currentPosition.coords.longitude,
				userid: userid,
				groupid: groupid
			}
		);	
	}
	
	if(usercoordinatestimer !=null){
		clearTimeout(usercoordinatestimer );	
	}
	usercoordinatestimer = setTimeout("initGeoPosition()",20000);
	
}
 

function verifyLogin(){
	
	nick = $.cookie('ciccit_nick');
	if(nick==null){
		isAuth = false;	 
	} else {
		isAuth = true;
		userid = $.cookie('ciccit_id');
		$("div#account").html("<input type='button' class='topbarbutton' value='logout' onClick='logout();'/>");
	}
	
}
 
 
function initButtons(){
	 
	$("div#map").off("click");
	$("div#map").click(function(){
		loadSection("map");	
	});
	
	$("div#groups").off("click");
	$("div#groups").click(function(){
		loadSection("groups");	
	});
	
	$("div#stars").off("click");
	$("div#stars").click(function(){
		loadSection("stars");	
	});
	
	$("div#messaging").off("click");
	$("div#messaging").click(function(){
		loadSection("msg");	
	});
	
	$("div#info").off("click");
	$("div#info").click(function(){
		loadSection("info");	
	}); 
	
	
	
	$("div#createnewgroupbox").off("click");
	$("div#createnewgroupbox").click(function(){
		newGroup();	
	}); 
	 
	 
	 
	$("div.groupbox").off("click");
	$("div.groupbox").click(function(){
		openGroup(  $(this).attr("id") );	
	}); 
	 
	$("div#togglemsg").off("click"); 
	$("div#togglemsg").click(function(){
		$("div#groupmessaging").toggle();
		resizehandler();
	});
}
 
 
function openGroup( id){
	
	currentConstellationMarkers = new Array();
	groupMarkers = new Array();
	onStarMarkers = new Array();
	
	var idg = id.substring(2);
			$("div#loader").fadeIn();	
			$("div#maindiv").load("groupDetails.php",
				{
					userid: userid,
					groupid: idg
				},
				function(){
					
					resizehandler();
					autoScrollMap = true;
					initializeGroupMap();
					initGeoPosition();
					initButtons();
					$("div#loader").fadeOut();
					getStarsForConstellation(idcostellazione);
				}
			);
	
	
}




function resizehandler(){
	
	W = $(window).width();
	H = $(window).height();
	$("div#mapcontainer").height(H-$("div#topbar").height()-$("div#toolbar").height());
	$("div#mapcontainer").width(W);
	
	
	$("div#loader").width(W);
	$("div#loader").height(H-$("div#topbar").height()-$("div#toolbar").height());
	$("div#loader").css("top",$("div#topbar").height());
	$("div#loader").css("left",$("div#mapcontainer").css("left"));
	
	$("div#loaderholder").css("margin-top",  $("div#loader").height()/2 - $("div#loaderholder").height()/2 );
	
	$("div#maindiv").width(W);
	$("div#maindiv").height(H-$("div#topbar").height()-$("div#toolbar").height());
	$("div#maindiv").css("top",$("div#topbar").height());
	
	$("div#groupMapHolder").width(W);
	
	if(  $("div#groupmessaging").is(":visible") ){
		$("div#groupMapHolder").height($("div#maindiv").height() - $("div#groupDetailsHead").height() - $("div#groupmessaging").height() );
	} else {
		$("div#groupMapHolder").height($("div#maindiv").height() - $("div#groupDetailsHead").height() );
	}
	$("div#groupMapBox").width(W);
	$("div#groupMapBox").height($("div#groupMapHolder").height());
	
	if(  $("div#groupmessaging").is(":visible") ){
		$("div#togglemsg").css("bottom",$("div#groupmessaging").height() - 5);
	} else {
		$("div#togglemsg").css("bottom",- 5);
	}
	$("div#togglemsg").css("right",5);
	
	$("div#youwin").css("top",H/2-$("div#youwin").height()/2);
	$("div#youwin").css("left",W/2-$("div#youwin").width()/2);
} 

function loadSection(s){
	
	currentSection = s;
	
	
	
	if(currentSection=="map"){
	
		$("div#loader").fadeIn();	
		$("div#maindiv").load("mapsDiv.php",function(){
			resizehandler();
			initializeMap();
			//initGeoPosition();
			initButtons();
			
			autoScrollMap = true;
			
			if(usercoordinatestimer !=null){
				clearTimeout(usercoordinatestimer );	
			}
			usercoordinatestimer = setTimeout("initGeoPosition()",1000);
			
			
			$("div#loader").fadeOut();
			
			getAllStars();
			
		});
		
	} else if(currentSection=="groups"){
		
		if(isAuth){
			
			$("div#loader").fadeIn();	
			$("div#maindiv").load("groups.php",function(){
				
				$("div#yourgroupsboxinner").load("groupManager.php?cmd=mygroups",
					{userid:userid},
					function(){
						$("div#allgroupsboxinner").load("groupManager.php?cmd=allgroups",
							{userid:userid},
							function(){
								resizehandler();
								initButtons();
								$("div#loader").fadeOut();
							}
						);
						
					}
				);
				
				
			});
			
		} else {
			sectionToGoToAfterLogin = "groups";
			login();	
		}
		
	} else if(currentSection=="stars"){
		
		
	} else if(currentSection=="msg"){
		
		if(isAuth){
			
			//carica	
		} else {
			sectionToGoToAfterLogin = "msg";
			login();	
		}
		
	} else if(currentSection=="info"){
		
		
	}
	 
}


var sectionToGoToAfterLogin = "map";
function login(){
	
		$("div#loader").fadeIn();	
		$("div#maindiv").load("login.php",function(){
			$("div#loader").fadeOut();
		});
	
}

function doLogin(cmd){
	
	
	if($("input#loginfield").val()=="" || $("input#pwdfield").val()=="" ){
		alert("ATTENZIONE! Inserisci il tuo login e password! Se non sei ancora registrato, inserisci il nickname che desideri usare e scegli una password.");
	} else {
	
	$("div#loadhidden").load("accountManager.php",
		{
			login: $("input#loginfield").val(),
			pwd: 	$("input#pwdfield").val(),
			cmd: cmd
		},function(){
			
			var data = $("div#loadhidden").html();
			var dataa = data.split("|");
			
			
			if(dataa[0]=="OK"){
				nick = $("input#loginfield").val();
				isAuth = true;
				userid = dataa[1];
				$.cookie('ciccit_nick', nick, { expires: 7 });
				$.cookie('ciccit_id', dataa[1], { expires: 7 });
				$("div#account").html("<input type='button' class='topbarbutton' value='logout' onClick='logout();'/>");
				loadSection(sectionToGoToAfterLogin);
			} else if(dataa[0]=="NOK_WRONG_PWD"){
				// login esistente, pwd sbagliata
				$("div#loginerrorbox").html("Il login è esistente, ma la password è sbagliata.");
			} else if(dataa[0]=="NOK_NO_NIK"){
				// login non esistente: vuoi registrarti?
				$("div#loginerrorbox").html("Il nickname è inesistente. Registrati!");
				if( confirm("Il nickname non esiste: vuoi registrarti?") ){
					doLogin("register");
				}
			} 
			
		}
	
	);
	}
}

function logout(){
	
	if(confirm("Vuoi uscire?")){
		$.cookie('ciccit_nick', null);
		$.cookie('ciccit_id',null);
		isAuth = false;
		nick = null;
		userid = -1;
		sectionToGoToAfterLogin = "map";
		$("div#account").html('<input type="button" class="topbarbutton" value="login" onClick="login();"/>');
		loadSection(sectionToGoToAfterLogin);
		
	}
}



	  function initializeMap() {
		  
		mapStyleStyle = new google.maps.StyledMapType(mapStyle, {name: "CICCIT Style"});
		  
		  
		
        var myOptions = {
          center: new google.maps.LatLng(-34.397, 150.644),
          zoom: 13,
		  mapTypeControlOptions: {
      			mapTypeIds: []
    		}
        };
        map = new google.maps.Map(document.getElementById("mapcontainer"), myOptions);
		
		map.mapTypes.set('ciccit_map_style', mapStyleStyle);
  		map.setMapTypeId('ciccit_map_style');
  
		//initGeoPosition();
	
      }
	  
	  
	  
	  
	  function initializeGroupMap() {
		  
		mapStyleStyle = new google.maps.StyledMapType(mapStyle, {name: "CICCIT Style"});
		  
		  
		
        var myOptions = {
          center: new google.maps.LatLng(-34.397, 150.644),
          zoom: 13,
		  mapTypeControlOptions: {
      			mapTypeIds: []
    		}
        };
		
        map = new google.maps.Map(document.getElementById("groupMapBox"), myOptions);
		
		map.mapTypes.set('ciccit_map_style', mapStyleStyle);
  		map.setMapTypeId('ciccit_map_style');
  
		//initGeoPosition();
	
      }
	  
	  
	  
function newGroup(){
	
	var groupname = prompt("Scegli il nome del nuovo gruppo:");
	
	groupname = groupname;
	
	if(groupname==""){
		alert("Attenzione! Il nome del gruppo non può essere vuoto.");
		newGroup();	
	} else {
		
		$("div#loadhidden").load("groupManager.php",
		{
			userid: userid,
			groupname: 	groupname,
			cmd: "create"
		},function(){
			
			var data = $("div#loadhidden").html();
			var dataa = data.split("|");
			
			if(dataa[0]=="OK"){
				loadSection(currentSection);
			} else if(dataa[0]=="NOK_EXISTS"){
				// gruppo esiste: vuoi unirti?
				if(confirm("Il gruppo esiste di già. Vuoi unirti?")){
					// registrati	
					$("div#loadhidden").load("groupManager.php",
					{
						userid: userid,
						groupname: 	groupname,
						cmd: "register"
					},function(){
						var data = $("div#loadhidden").html();
						var dataa = data.split("|");
						if(dataa[0]=="OK"){
							loadSection(currentSection);	
						} else{
							alert("Ci dispiace, non è stato possibile aggiungerti al gruppo.");	
						}
					});
					
				}
			} else if(dataa[0]=="NOK_ERROR"){
				// errore generico
				alert("Si è verificato un errore nella creazione del gruppo. Riprova.");
			} 
			
		}
	
		);
		
		
	}
	
}



function chooseCostellazione(cid,gid){
	
	$("div#loader").fadeIn();	
	$("div#loadhidden").load("groupManager.php",
		{
			userid: userid,
			cid: 	cid,
			groupid: gid,
			cmd: "chooseStar"
		},function(){
			openGroup("g_" + gid); 
			$("div#loader").fadeOut();
		}
	);
	
}

function chooseStars(gname,idg){
	
	$("div#loader").fadeIn();	
	$("div#maindiv").load("chooseStars.php",
		{
			userid: userid,
			groupname: 	gname,
			groupid: idg
		},function(){
			
			
			$("div#loader").fadeOut();
		}
	);

}

function joinGroup(gname,idg){
	
	
	$("div#loader").fadeIn();	
	$("div#loadhidden").load("groupManager.php",
		{
			userid: userid,
			groupname: 	gname,
			cmd: "register"
		},function(){
			
			
		$("div#maindiv").load("groupDetails.php",
				{
					userid: userid,
					groupid: idg
				},
				function(){
				
					resizehandler();
					initButtons();
					$("div#loader").fadeOut();
				}
			);
			
			
		}
	);
}


function sendGroupMessage(){
	
	var msgToSend = $("input#sendMessageToGroupInput").val();
	var fromID= $("input#sendMessageToGroupInputUID").val();
	var toGroup = $("input#sendMessageToGroupInputGID").val();
	$("div#loadhidden").load("sendMessage.php",
		{
			userid: fromID,
			groupid: toGroup,
			msg: msgToSend
		},function(){
			$("input#sendMessageToGroupInput").val("");
		}
	);
	
}


function getStarsForConstellation(cid){
	$("div#loadhidden").load("getStars.php",
		{
			cid: cid
		},function(){
			if(map!=null){
				
				for(var i=0; i<currentConstellationMarkers.length; i++){
					currentConstellationMarkers[i].setMap(null);	
				}
				currentConstellationMarkers = new Array();
				
				var stringa = $("div#loadhidden").html();
				var stelle = stringa.split("|");
				for(var i = 0; i<stelle.length; i++){
					var stella = stelle[i].split("#");
					var myLatlng = new google.maps.LatLng(parseFloat(stella[0]),parseFloat(stella[1]));
					var marker = new google.maps.Marker({
      					position: myLatlng,
      					map: map,
						icon: staricon,
      					title:"Stella!"
  					});	
					currentConstellationMarkers.push(marker);
				}
			}
		}
	);
}


function getAllStars(){
	$("div#loadhidden").load("getAllStars.php",
		function(){
			if(map!=null){
				
				for(var i=0; i<currentConstellationMarkers.length; i++){
					currentConstellationMarkers[i].setMap(null);	
				}
				currentConstellationMarkers = new Array();
				
				var stringa = $("div#loadhidden").html();
				var stelle = stringa.split("|");
				for(var i = 0; i<stelle.length; i++){
					var stella = stelle[i].split("#");
					var myLatlng = new google.maps.LatLng(parseFloat(stella[0]),parseFloat(stella[1]));
					var marker = new google.maps.Marker({
      					position: myLatlng,
      					map: map,
						icon: staricon,
      					title:"Stella!"
  					});	
					currentConstellationMarkers.push(marker);
				}
			}
		}
	);
}


var mapStyle = [ { stylers: [ { visibility: "off" } ] },{ featureType: "water", elementType: "geometry", stylers: [ { visibility: "on" }, { hue: "#0000ff" }, { lightness: -75 } ] },{ featureType: "landscape.natural", elementType: "geometry", stylers: [ { visibility: "on" }, { saturation: 29 }, { hue: "#0008ff" }, { lightness: -67 } ] },{ featureType: "road", elementType: "geometry", stylers: [ { visibility: "on" }, { saturation: 61 }, { lightness: -78 }, { hue: "#0008ff" } ] },{ featureType: "transit", elementType: "geometry", stylers: [ { visibility: "on" }, { lightness: -100 } ] },{ featureType: "road", elementType: "labels", stylers: [ { visibility: "off" }, { saturation: -100 }, { hue: "#333333" }, { lightness: -50 } ] } ];